//Astronomy_Listener.java

import ij.*;
import ij.plugin.*;
import ij.process.*;

import astroj.*;
import astroj.AstroStackWindow.*;

import java.awt.Frame;

/**
 * @author K.A. Collins, University of Louisville
 * @version 1.0
 * @date 2010-Jul-25
 */
public class Astronomy_Listener implements PlugIn, ImageListener
    {
    public static final boolean REFRESH = true;
    public static final boolean NEW = false;
    public static final boolean RESIZE = true;
    public static final boolean NORESIZE = false;

    public void run (String arg)
		{
        if (IJ.versionLessThan("1.35l")) return;
        ImagePlus.addImageListener(this);
        }


    public void imageOpened(ImagePlus imp)
        {
        boolean autoConvert = true;
        autoConvert = Prefs.get("Astronomy_Tool.autoConvert", autoConvert);
        if (autoConvert)
            {
            Frame openFrame = imp.getWindow();
            Class<?> mainComponentClass = openFrame.getClass();
            if (mainComponentClass.getName() != "astroj.AstroStackWindow")
                {
                AstroCanvas ac = new AstroCanvas(imp);
                AstroStackWindow astroWindow = new AstroStackWindow(imp, ac, NEW, RESIZE);
                }
            }
        }

    public void imageClosed(ImagePlus imp)
        {
        }

    public void imageUpdated(ImagePlus imp)
        {
        Frame openFrame = imp.getWindow();
        Class<?> mainComponentClass = openFrame.getClass();
        if (mainComponentClass.getName().equals("astroj.AstroStackWindow"))
            {
            astroj.AstroStackWindow asw = (astroj.AstroStackWindow) openFrame;
            if (asw.isReady && !asw.minMaxChanged)
                {
                asw.setAstroProcessor(false);
                }
            else
                {
                asw.minMaxChanged = false;
                }
            }
        }
    }

